<?php

defined('_JEXEC') or die('Restricted access');

/**
 * @author Agung FasaPay
 * @version 1 2013-06-25
 *
 * https://www.fasapay.com
 */
if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentFasapay extends vmPSPlugin {

    // instance of class
    public static $_this = FALSE;

    function __construct(& $subject, $config) {

        //if (self::$_this)
        //   return self::$_this;
        parent::__construct($subject, $config);

        $this->_loggable = TRUE;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $this->_tablepkey = 'id'; //virtuemart_fasapay_id';
        $this->_tableId = 'id'; //'virtuemart_fasapay_id';
        $varsToPush = array('fp_acc' => array('', 'char'),
            'fp_acc_from' => array('', 'char'),
            'fp_store' => array('', 'char'),
            'fp_item' => array('', 'char'),
            'fp_amnt' => array('', 'int'),
            'fp_fee_mode' => array(0, 'char'),
            'fp_currency' => array('', 'char'),
            'payment_currency' => array('', 'int'),
            'fp_comments' => array('', 'char'),
            'fp_merchant_ref' => array(0, 'int'),
            'fp_success_url' => array('', 'char'),
            'fp_success_method' => array('', 'char'),
            'fp_status_success' => array('', 'char'),
            'fp_fail_url' => array('', 'char'),
            'fp_fail_method' => array('', 'char'),
            'fp_status_fail' => array('', 'char'),
            'fp_status_url' => array('', 'char'),
            'fp_status_method' => array('', 'char'),
            'fp_status_status' => array('', 'char'),
            'fp_secret_word' => array('', 'char'),
            'debug' => array(0, 'int'),
            'sandbox' => array(0, 'int'),
            'countries' => array('', 'char'),
            'min_amount' => array('', 'int'),
            'max_amount' => array('', 'int'),
            'fasapay_payment_logos' => array('', 'char'),
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

        //self::$_this = $this;
    }

    /**
     * @return string
     */
    public function getVmPluginCreateTableSQL() {

        return $this->createTableSQL('Payment Fasapay Table');
    }

    /**
     * @return array
     */
    function getTableSQLFields() {

        $SQLfields = array(
            'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(1) UNSIGNED',
            'order_number' => 'char(64)',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
            'payment_name' => 'varchar(5000)',
            'payment_order_total' => 'decimal(15,5) NOT NULL',
            'payment_currency' => 'smallint(1)',
            'cost_per_transaction' => 'decimal(10,2)',
            'cost_percent_total' => 'decimal(10,2)',
            'tax_id' => 'smallint(1)',
            'fp_session_id' => 'varchar(255)',
            'fasapayresponse_raw' => 'text',
//Returned report from fasapay
            'fp_paidto' => 'char(10)',
            'fp_paidby' => 'char(10)',
            'fp_amnt' => 'decimal(19, 2)',
            'fp_fee_amnt' => 'decimal(19, 2)',
            'fp_fee_mode' => 'char(3)',
            'fp_total' => 'decimal(19, 2)',
            'fp_currency' => 'char(3)',
            'fp_batchnumber' => 'char(13)',
            'fp_store' => 'char(50)',
            'fp_timestamp' => 'datetime',
            'fp_merchant_ref' => 'char(50)',
            'fp_hash' => 'varchar(255)',
            'fp_hash_2' => 'varchar(255)',
        );
        return $SQLfields;
    }

    /**
     * @param $cart
     * @param $order
     * @return bool|null
     */
    function plgVmConfirmedOrder($cart, $order) {

        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        $session = JFactory::getSession();
        $return_context = $session->getId();
        $this->_debug = $method->debug;
        $this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }
        if (!class_exists('VirtueMartModelCurrency')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
        }

        $address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

        if (!class_exists('TableVendors')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
        }
        $vendorModel = VmModel::getModel('Vendor');
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $vendorModel->addImages($vendor, 1);
        $this->getPaymentCurrency($method);

        $currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');
        if (!in_array($currency_code_3, array('IDR', 'USD'))) {
            vmInfo($currency_code_3);
            vmInfo(JText::_('VMPAYMENT_FASAPAY_CURRENCY_NOT_SUPPORTED'));
            return FALSE;
        }
        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, FALSE), 2);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
        if ($totalInPaymentCurrency <= 0) {
            vmInfo(JText::_('VMPAYMENT_FASAPAY_PAYMENT_AMOUNT_INCORRECT'));
            return FALSE;
        }
        $fp_url = ($method->fp_sandbox) ? 'https://sandbox.fasapay.com/' : 'https://sci.fasapay.com/';
        $fp_acc = $method->fp_acc;
        if (empty($fp_acc)) {
            vmInfo(JText::_('VMPAYMENT_FASAPAY_ACCOUNT_NOT_SET'));
            return FALSE;
        }
        $fp_store = $method->fp_store;
        if (empty($fp_store)) {
            vmInfo(JText::_('VMPAYMENT_FASAPAY_STORE_NOT_SET'));
            return FALSE;
        }

        ///GET FEE MODE
        $fp_fee_mode = $method->fp_fee_mode;


        $post_variables = Array(
            'fp_acc' => $fp_acc,
            'fp_store' => $fp_store,
            'fp_item' => JText::_('VMPAYMENT_FASAPAY_ORDER_NUMBER') . ': ' . $order['details']['BT']->order_number,
            'fp_amnt' => $totalInPaymentCurrency,
            'fp_fee_mode' => $fp_fee_mode,
            'fp_currency' => $currency_code_3,
            'fp_comments' => JText::_('VMPAYMENT_FASAPAY_ORDER_NUMBER') . ': ' . $order['details']['BT']->order_number,
            'fp_merchant_ref' => $order['details']['BT']->order_number,
            'fp_success_url' => $this->getFasapaySuccessUrl(),
            'fp_success_method' => 'POST',
            'fp_fail_url' => $this->getFasapayFailUrl(),
            'fp_fail_method' => 'POST',
            //'fp_status_url'=>$this->getFasapayStatusUrl(),
            //'fp_status_method'=>'POST',
            'pm' => $order['details']['BT']->virtuemart_paymentmethod_id,
            'no' => $order['details']['BT']->order_number,
            'session_id' => $return_context
        );

        // Prepare data that should be stored in the database
        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['payment_name'] = $this->renderPluginName($method, $order);
        $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
        $dbValues['fp_session_id'] = $return_context;
        $dbValues['cost_per_transaction'] = $method->cost_per_transaction;
        $dbValues['cost_percent_total'] = $method->cost_percent_total;
        $dbValues['payment_currency'] = $method->payment_currency;
        $dbValues['email_currency'] = $email_currency;
        $dbValues['payment_order_total'] = $totalInPaymentCurrency;
        $dbValues['tax_id'] = $method->tax_id;
        $this->storePSPluginInternalData($dbValues);

        //$url = $this->_getfasapayUrlHttps ($method);
        // add spin image
        $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
        $html .= '<form action="' . $fp_url . '" method="post" name="vm_fasapay_form" >';
        $html .= '<img src="https://www.fasapay.com/images/logo_email.png" alt="FasaPay" /> <br />';
        $html .= '<input type="submit"  value="' . JText::_('VMPAYMENT_FASAPAY_REDIRECT_MESSAGE') . '" />';
        foreach ($post_variables as $name => $value) {
            $html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
        }
        $html .= '</form></div>';
        $html .= ' <script type="text/javascript">';
        $html .= ' document.vm_fasapay_form.submit();';
        $html .= ' </script></body></html>';

        // 	2 = don't delete the cart, don't send email and don't redirect
        $cart->_confirmDone = FALSE;
        $cart->_dataValidated = FALSE;
        $cart->setCartIntoSession();
        JRequest::setVar('html', $html);
    }

    /**
     * @param $html
     * @return bool|null|string
     */
    function plgVmOnPaymentResponseReceived(&$html) {

        if (!class_exists('VirtueMartCart')) {
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
        }
        if (!class_exists('shopFunctionsF')) {
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
        }
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        // the payment itself should send the parameter needed.
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
        $order_number = JRequest::getString('fp_merchant_ref', '');
        $fasapay_data = JRequest::get('post');
        $vendorId = 0;
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return NULL;
        }

        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return NULL;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        $payment_name = $this->renderPluginName($method);
        $html = $this->_getPaymentResponseHtml($paymentTable, $payment_name, $fasapay_data);
        VmInfo(Jtext::_('VMPAYMENT_FASAPAY_PAYMENT_SUCCESS'));
        $session = JFactory::getSession();
        $return_context = $session->getId();
        if (empty($paymentTable->fp_paidby) && strcmp($paymentTable->fp_session_id, $return_context) === 0) {
            $this->setStatusUserSuccess($virtuemart_order_id, $method);
        }

        //We delete the old stuff
        // get the correct cart / session
        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        return TRUE;
    }

    /**
     * @return bool|null
     */
    function plgVmOnUserPaymentCancel() {

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        $order_number = JRequest::getString('fp_merchant_ref', '');
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);


        if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {

            return NULL;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {

            return NULL;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {

            return NULL;
        }


        VmInfo(Jtext::_('VMPAYMENT_FASAPAY_PAYMENT_CANCELLED'));
        $session = JFactory::getSession();
        $return_context = $session->getId();
        $method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
        if (strcmp($paymentTable->fp_session_id, $return_context) === 0) {
            $this->setStatusUserCancel($virtuemart_order_id, $method);
        }
        return TRUE;
    }

    
    /**
     * @return bool|null
     */
    function plgVmOnPaymentNotification() {

        //$this->_debug = true;
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }
        $fasapay_data = JRequest::get('post');
        if (!isset($fasapay_data['fp_merchant_ref'])) {
            return FALSE;
        }

        $order_number = $fasapay_data['fp_merchant_ref'];
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($fasapay_data['fp_merchant_ref']))) {
            return FALSE;
        }

        $vendorId = 0;
        if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
            return FALSE;
        }

        $method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        $this->_debug = $method->debug;

        $this->logInfo('fasapay_data ' . implode('   ', $fasapay_data), 'message');
        // _checkHash check if data == hash
        if (!$this->_checkHash($fasapay_data, $method)) {
            $this->logInfo('fasapay_data _checkHash FALSE', 'message');
            return FALSE;
        } else {
            $this->logInfo('fasapay_data _checkHash TRUE', 'message');
        }

        $modelOrder = VmModel::getModel('orders');
        $order = array();

        $lang = JFactory::getLanguage();
        $order['customer_notified'] = 1;

        // check amount currency is correct
        if (!$this->_check_paidto_amount_currency($payments, $fasapay_data, $method)) {
            $this->logInfo('fasapay_data _check_paidto_amount_currency FALSE', 'message');
            return FALSE;
        } else {
            $this->logInfo('fasapay_data _check_paidto_amount_currency TRUE', 'message');
        }
        // now we can process the payment
        $order['order_status'] = $method->fp_status_status;
        $order['comments'] = JText::sprintf('VMPAYMENT_FASAPAY_PAYMENT_STATUS_CONFIRMED', $order_number);

        $this->_storeFasapayInternalData($method, $fasapay_data, $virtuemart_order_id, $payments[0]->virtuemart_paymentmethod_id);
        $this->logInfo('plgVmOnPaymentNotification return new_status:' . $order['order_status'], 'message');

        $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
        //// remove vmcart
        if (isset($fasapay_data['session_id'])) {
            $this->emptyCart($fasapay_data['session_id'], $order_number);
        }
        //die();
    }

    /**
     * Display stored payment data for an order
     *
     * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

        if (!$this->selectedThisByMethodId($payment_method_id)) {
            return NULL; // Another method was selected, do nothing
        }

        if (!($payments = $this->_getFasapayInternalData($virtuemart_order_id))) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }

        $html = '<table class="adminlist" width="50%">' . "\n";
        $html .= $this->getHtmlHeaderBE();
        $code = "fasapay_response_";
        $first = TRUE;
        foreach ($payments as $payment) {
            $html .= '<tr class="row1"><td>' . JText::_('VMPAYMENT_FASAPAY_DATE') . '</td><td align="left">' . $payment->created_on . '</td></tr>';
            // Now only the first entry has this data when creating the order
            if ($first) {
                $html .= $this->getHtmlRowBE('FASAPAY_PAYMENT_NAME', $payment->payment_name);
                // keep that test to have it backwards compatible. Old version was deleting that column  when receiving an IPN notification
                if ($payment->payment_order_total and $payment->payment_order_total != 0.00) {
                    $html .= $this->getHtmlRowBE('FASAPAY_PAYMENT_ORDER_TOTAL', $payment->payment_order_total . " " . shopFunctions::getCurrencyByID($payment->payment_currency, 'currency_code_3'));
                }
                if ($payment->fp_paidby) {
                    $html .= $this->getHtmlRowBE('FASAPAY_PAID_BY', $payment->fp_paidby);
                }
                if ($payment->fp_fee_mode) {
                    $html .= $this->getHtmlRowBE('FASAPAY_FEEMOD', $payment->fp_fee_mode);
                }
                if ($payment->fp_fee) {
                    $html .= $this->getHtmlRowBE('FASAPAY_FEE', $payment->fp_fee);
                }
                if ($payment->fp_total) {
                    $html .= $this->getHtmlRowBE('FASAPAY_PAID_TOTAL', $payment->fp_total);
                }

                $first = FALSE;
            }
            foreach ($payment as $key => $value) {
                // only displays if there is a value or the value is different from 0.00 and the value
                if ($value) {
                    if (substr($key, 0, strlen($code)) == $code) {
                        $html .= $this->getHtmlRowBE($key, $value);
                    }
                }
            }
        }
        $html .= '</table>' . "\n";
        return $html;
    }

    /**
     * @param $method
     * @param $fasapay_data
     * @param $virtuemart_order_id
     */
    function _storeFasapayInternalData($method, $fasapay_data, $virtuemart_order_id, $virtuemart_paymentmethod_id) {
        $response_fields = array();

        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
        $q .= ' `virtuemart_order_id` = "' . $virtuemart_order_id . '"';
        $db->setQuery($q);
        $databaseFields = $db->loadAssoc();
        foreach ($databaseFields as $key => $value) {
            $response_fields[$key] = $value;
        }

        $post_msg = '';
        foreach ($fasapay_data as $key => $value) {
            $post_msg .= $key . "=" . $value . "<br />";
        }

        //$response_fields[$this->_tablepkey] = $this->_getTablepkeyValue($virtuemart_order_id);
        $response_fields['payment_name'] = $this->renderPluginName($method);
        $response_fields['fasapayresponse_raw'] = $post_msg;
        $response_fields['order_number'] = $fasapay_data['fp_merchant_ref'];
        $response_fields['virtuemart_order_id'] = $virtuemart_order_id;
        $response_fields['virtuemart_paymentmethod_id'] = $virtuemart_paymentmethod_id;
        $response_fields['fp_session_id'] = $fasapay_data['session_id'];
        $response_fields['fp_paidto'] = $fasapay_data['fp_paidto'];
        $response_fields['fp_paidby'] = $fasapay_data['fp_paidby'];
        $response_fields['fp_amnt'] = $fasapay_data['fp_amnt'];
        $response_fields['fp_fee_amnt'] = $fasapay_data['fp_fee_amnt'];
        $response_fields['fp_fee_mode'] = $fasapay_data['fp_fee_mode'];
        $response_fields['fp_total'] = $fasapay_data['fp_total'];
        $response_fields['fp_currency'] = $fasapay_data['fp_currency'];
        $response_fields['fp_batchnumber'] = $fasapay_data['fp_batchnumber'];
        $response_fields['fp_store'] = $fasapay_data['fp_store'];
        $response_fields['fp_timestamp'] = $fasapay_data['fp_timestamp'];
        $response_fields['fp_merchant_ref'] = $fasapay_data['fp_merchant_ref'];
        $response_fields['fp_hash'] = $fasapay_data['fp_hash'];
        $response_fields['fp_hash_2'] = $fasapay_data['fp_hash_2'];

        $this->logInfo('saveInternal ' . implode('[|]', $response_fields), 'message');

        //$preload=true   preload the data here too preserve not updated data
        $this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', TRUE);
    }

    /**
     * @param        $virtuemart_order_id
     * @param string $order_number
     * @return mixed|string
     */
    function _getFasapayInternalData($virtuemart_order_id, $order_number = '') {

        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
        if ($order_number) {
            $q .= " `order_number` = '" . $order_number . "'";
        } else {
            $q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
        }

        $db->setQuery($q);
        if (!($payments = $db->loadObjectList())) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $payments;
    }

    /**
     * @param VirtueMartCart $cart
     * @param                $method
     * @param                $cart_prices
     * @return int
     */
    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {

        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    /**
     * Check if the payment conditions are fulfilled for this payment method
     *
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
    protected function checkConditions($cart, $method, $cart_prices) {

        $this->convert($method);

        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

        $amount = $cart_prices['salesPrice'];
        $amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount OR
                ($method->min_amount <= $amount AND ($method->max_amount == 0)));

        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }
        // probably did not gave his BT:ST address
        if (!is_array($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }

        if (!isset($address['virtuemart_country_id'])) {
            $address['virtuemart_country_id'] = 0;
        }
        if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
            if ($amount_cond) {
                return TRUE;
            }
        }

        return FALSE;
    }

    /**
     * @param $method
     */
    function convert($method) {

        $method->min_amount = (float) $method->min_amount;
        $method->max_amount = (float) $method->max_amount;
    }

    /**
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     *
     * @author ValÃ©rie Isaksen
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     * @author Max Milbers
     * @author ValÃ©rie isaksen
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart, &$msg) {

        return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object  $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {

        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    /**
     * @param VirtueMartCart $cart
     * @param array          $cart_prices
     * @param                $cart_prices_name
     * @return bool|null
     */
    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     *
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

        return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {

        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers

      public function plgVmOnCheckoutCheckDataPayment($psType, VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {

        return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderPayment(  $_formData) {
      return null;
      }
     */
    /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }
     */
    /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
      return null;
      }
     */

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }
     */
    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {

        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    /**
     * @param $name
     * @param $id
     * @param $table
     * @return bool
     */
    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {

        return $this->setOnTablePluginParams($name, $id, $table);
    }

    function setStatusUserCancel($virtuemart_order_id, $method = NULL) {

        if ($virtuemart_order_id) {
            // set the order to cancel , to handle the stock correctly
            if (!class_exists('VirtueMartModelOrders')) {
                require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
            }

            if ($method) {
                $status = $method->fp_status_fail;
            } else {
                $status = 'X';
            }

            $modelOrder = VmModel::getModel('orders');
            $order['order_status'] = $status;
            $order['virtuemart_order_id'] = $virtuemart_order_id;
            $order['customer_notified'] = 0;
            $order['comments'] = JText::_('COM_VIRTUEMART_PAYMENT_CANCELLED_BY_SHOPPER');
            $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
            //$modelOrder->remove (array('virtuemart_order_id' => $virtuemart_order_id));
        }
    }

    function setStatusUserSuccess($virtuemart_order_id, $method = NULL) {

        if ($virtuemart_order_id) {
            //if confirmed by status notification return false



            if (!class_exists('VirtueMartModelOrders')) {
                require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
            }

            if ($method) {
                $status = $method->fp_status_success;
            } else {
                $status = 'X';
            }

            $modelOrder = VmModel::getModel('orders');
            $order['order_status'] = $status;
            $order['virtuemart_order_id'] = $virtuemart_order_id;
            $order['customer_notified'] = 0;
            $order['comments'] = JText::_('VMPAYMENT_FASAPAY_SUCCESS_LANDING_PAGE_COMMENT');
            $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
            //$modelOrder->remove (array('virtuemart_order_id' => $virtuemart_order_id));
        }
    }

    function getFasapaySuccessUrl() {
        return JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived');
    }

    function getFasapayFailUrl() {
        return JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel');
    }

    function getFasapayStatusUrl() {
        return JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component');
    }

    function _check_paidto_amount_currency($payments, $fasapay_data, $method) {

        $currency_code_3 = shopFunctions::getCurrencyByID($payments[0]->payment_currency, 'currency_code_3');
        if (
                ($method->fp_acc == $fasapay_data['fp_paidto']) &&
                ($payments[0]->payment_order_total == $fasapay_data['fp_amnt']) &&
                ($currency_code_3 == $fasapay_data['fp_currency'])) {
            return TRUE;
        }

        if ($method->fp_fee_mode == 'FsC' || $method->fp_fee_mode == $fasapay_data['fp_fee_mode']) {
            return TRUE;
        }


        $mailsubject = "[FasaPay] IPN-Transaction";
        $mailbody = "Hello,
		An SCI-IPN notification was received with an invalid amount, currency, or fee_mode
		----------------------------------
		SCI-IPN Notification content:
		";
        foreach ($fasapay_data as $key => $value) {
            $mailbody .= $key . " = " . $value . "\n\n";
        }
        $this->sendEmailToVendorAndAdmins($mailsubject, $mailbody);

        return FALSE;
    }

    private function _checkHash($fasapay_data, $method) {
        $str = $fasapay_data['fp_paidto'] . ":" .
                $fasapay_data['fp_paidby'] . ":" .
                $fasapay_data['fp_store'] . ":" .
                $fasapay_data['fp_amnt'] . ":" .
                $fasapay_data['fp_fee_amnt'] . ":" .
                $fasapay_data['fp_fee_mode'] . ":" .
                $fasapay_data['fp_total'] . ":" .
                $fasapay_data['fp_batchnumber'] . ":" .
                $fasapay_data['fp_currency'] . ":" .
                $method->fp_secret_word;
        $hash = strtolower(hash('sha256', $str));

        $return = (strtolower($fasapay_data['fp_hash_2']) == $hash);
        if (!$return) {
            //NOTIFI ADMIN
            $mailsubject = "[FasaPay] IPN-INVALID-Transaction";
            $mailbody = "Hello,
			An SCI-IPN notification was received with an invalid hash
			----------------------------------
			SCI-IPN Notification content:
			";
            foreach ($fasapay_data as $key => $value) {
                $mailbody .= $key . " = " . $value . "\n\n";
            }
            $this->sendEmailToVendorAndAdmins($mailsubject, $mailbody);
        }

        //$this->logInfo ('plgVmFasapay hash Ceck : ' . $str .' | '.$hash.' | '.$fasapay_data['fp_hash_2'].' | '.$return , 'message');

        return $return;
    }

    /**
     * @param $paypalTable
     * @param $payment_name
     * @return string
     */
    function _getPaymentResponseHtml($fasapayTable, $payment_name, $fasapay_data) {

        $html = '<table>' . "\n";
        $html .= $this->getHtmlRow('FASAPAY_PAYMENT_NAME', $payment_name);
        if (!empty($fasapayTable)) {
            $html .= $this->getHtmlRow('FASAPAY_ORDER_NUMBER', $fasapayTable->order_number);
            $html .= $this->getHtmlRow('FASAPAY_PAYMENT_ORDER_TOTAL', $fasapayTable->payment_order_total);
            $html .= $this->getHtmlRow('FASAPAY_PAID_TO', $fasapay_data["fp_paidto"]);
            $html .= $this->getHtmlRow('FASAPAY_PAID_BY', $fasapay_data["fp_paidby"]);
            $html .= $this->getHtmlRow('FASAPAY_PAID_AMOUNT', $fasapay_data["fp_amnt"] . " " . $fasapay_data["fp_currency"]);
            $html .= $this->getHtmlRow('FASAPAY_PAID_FEE', $fasapay_data["fp_fee_amnt"] . " " . $fasapay_data["fp_currency"]);
            $html .= $this->getHtmlRow('FASAPAY_PAID_FEE_MOD', $fasapay_data["fp_fee_mode"]);
            $html .= $this->getHtmlRow('FASAPAY_PAID_TOTAL', $fasapay_data["fp_total"]);
        }
        $html .= '</table>' . "\n";

        return $html;
    }

}

// No closing tag
